
var spellclass = "@mozilla.org/spellchecker/myspell;1";
if ("@mozilla.org/spellchecker/hunspell;1" in Components.classes)
  spellclass = "@mozilla.org/spellchecker/hunspell;1";
else if ("@mozilla.org/spellchecker/engine;1" in Components.classes)
  spellclass = "@mozilla.org/spellchecker/engine;1";
var spellchecker = Components.classes[spellclass].createInstance(Components.interfaces.mozISpellCheckingEngine);

var spellcheckerInit = false;

// populate main menu
function SpellcheckingList() { 
	if (spellcheckerInit) return true;
	
	var sclist = {}, sccount = {};
	spellchecker.getDictionaryList(sclist, sccount);
	var popup = document.getElementById("SpellcheckingList"); 
	for (var i=0; i<sccount.value; i++) {
		var lang = sclist.value[i]; 
		var newmenu = document.createElement("menuitem");
		popup.appendChild(newmenu);
		newmenu.setAttribute("id", lang);
		newmenu.label = lang;
		newmenu.setAttribute("type", "radio");
		newmenu.setAttribute("name", "Spellchecking_Radio");
		newmenu.addEventListener("command", function(event) { SpellcheckingChange(event) } );
		if ( (spellchecker.dictionary == lang) || (spellchecker.dictionary == '' && i == 0) ) {
			newmenu.setAttribute("checked", true);
		}
	}
	spellcheckerInit = true;
}

function SpellcheckingChange(event) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("spellchecker.")
		.QueryInterface(Components.interfaces.nsIPrefBranch2);
	
	// BAUSTELLE ---------------------------------
	
	//alert(spellchecker.dictionary);
	
	spellchecker.dictionary = event.target.id;
	prefs.setCharPref("dictionary", spellchecker.dictionary);
	
	//spellchecker.SetCurrentDictionary(event.target.id); <--- für Textbox
	//alert(lang);
	//spellchecker.dictionary = lang;
	//alert(event.target.id + ', ' + spellchecker.dictionary);
	
	notifyAlert('Spell checking:', spellchecker.dictionary);
}


/*
 * ContextMenu
 */

function popupContextMenu(e) {
	var elem = e.target.tagName.toUpperCase();
	if ( contextMenuElements.indexOf(elem)<0 ) {
		e.preventDefault();
		return false;
	}
	if (e.defaultPrevented === true) {
		//e.target.contextmenu();
		//e.localTarget.dispatchEvent(e);
		e.trigger();
		//alert(e.target.name);
		return true;
	}
}
